#ifndef __BlobRadialStroke_H
#define __BlobRadialStroke_H

#include <QWidget>
#include <QTouchEvent>
#include <QRadialGradient>
#include <QList>
#include <QTimer>
#include <QImage>
#include <QDialog>
#include <QDebug>

class ComaPoint;

class BlobRadialStroke : public QWidget
{
        Q_OBJECT

public:
    enum STATE_RADIAL {
        CLOSED,
        READY_STROKE1,
        STROKE1,
        READY_STROKE2,
        STROKE2
    };
    static STATE_RADIAL state;

    static int delayActivate;
    BlobRadialStroke(QWidget *_parent = 0, bool _right=true);
    virtual ~BlobRadialStroke();


protected:
    virtual void paintEvent ( QPaintEvent *e);
    virtual bool event(QEvent * e);

    virtual bool touchBegin( QTouchEvent * e);
    virtual bool touchUpdate(QTouchEvent *e);
    virtual bool touchEnd(QTouchEvent *e);
    virtual bool press(QTouchEvent::TouchPoint);
    virtual bool drag(QTouchEvent::TouchPoint);
    virtual bool release(QTouchEvent::TouchPoint);

    virtual int numFromAngle(const QLineF& line);

    virtual QPoint barycenter(QList<QTouchEvent::TouchPoint>& points);
    virtual void setState(STATE_RADIAL _state){
        state = _state;
        if( state == CLOSED){ qDebug()<<"state closed"; }
        else if (state == READY_STROKE1){qDebug()<<"state ready_Strke 1"; }
        else if (state == STROKE1){qDebug()<<"state Stroke 1"; }
        else if (state == READY_STROKE2){qDebug()<<"state ready_Strke 2"; }
        else if (state == STROKE2){qDebug()<<"state Strke 2"; }
    }

signals:
    void barycenterMoved(const QPoint&);
    void initBarycenter(const QPoint&);

    void stroke1Changed(int);
    void stroke1Activated(int);
    void stroke2Changed(int);
    void stroke2Activated(int);
    void menuOpened();
    void menuClosed();

protected:
    QList<QTouchEvent::TouchPoint> previousPoints;
    int nbPreviousPoints;
    bool m_right;
    QLineF stroke1; int idStroke1; int valueStroke1;
    QLineF stroke2; int idStroke2; int valueStroke2;
    QLineF origin;
    int newIdPressed;


};





#endif // BlobRadialStroke_H
