#include <QDebug>
#include "fingercount.h"

#define FINGER_COUNT 1
#include <QTimer>


FingerCount::FingerCount():curIdMenu(0),curIdItem(0),curIdSec(-1)
{
}
FingerCount::~FingerCount() {}

//---------me-------
QAction* FingerCount::selectMenu(int i)
{
    if (i >= 0 && i<=5)
    {
        curIdMenu = i;
        return selectCurAction();
    }
    return 0;
}

//----------------
QAction* FingerCount::selectItem(FCSecond secondary, bool continuous)
{
    if (secondary == UP)
        curIdSec = 1;
    else if (secondary == DOWN)
        curIdSec = 2;
    else
        curIdSec = 0;
    return selectCurAction(continuous);
}

//----------------
QAction* FingerCount::selectItem(int i, FCSecond secondary, bool continuous)
{
    if (i >= 0 && i<=5)
    {
        curIdItem = i;
        if (secondary == UP)
            curIdSec = 1;
        else if (secondary == DOWN)
            curIdSec = 2;
        else
            curIdSec = 0;
        return selectCurAction(continuous);
    }
    return 0;
}

//----------------


QAction* FingerCount::selectItem(int menu, int item, FCSecond secondary, bool continuous)
{
    if (menu >= 0 && menu<=5 && item >=0 && item <=5 )
    {
        curIdMenu = menu;
        curIdItem = item;
        if (secondary == UP)
            curIdSec = 1;
        else if (secondary == DOWN)
            curIdSec = 2;
        else
            curIdSec = 0;
        return selectCurAction(continuous);
    }
    return 0;
}
//----------------
QAction* FingerCount::activateItem(int i, FCSecond secondary)
{
    if (i >= 0 && i<=5)
    {
        curIdItem = i;
        if (secondary == UP)
            curIdSec = 1;
        else if (secondary == DOWN)
            curIdSec = 2;
        else
            curIdSec = 0;
        QAction *act = activateCurAction();
        if (!act) return 0;
        qDebug()<<"activate : "<<act->text();
        //act->trigger(); //already performed in activateCurAction
        return act;
    }

    return 0;
}


//----------------
QAction* FingerCount::activateItem(int menu, int item, FCSecond secondary)
{
    if (menu >= 0 && menu<=5 && item >=0 && item <=5)
    {
        curIdMenu = menu;
        curIdItem = item;
        if (secondary == UP)
            curIdSec = 1;
        else if (secondary == DOWN)
            curIdSec = 2;
        else
            curIdSec = 0;
        QAction *act = activateCurAction();
        if (!act) return 0;
        qDebug()<<"activate : "<<act->text();
        //act->trigger(); //already performed in activateCurAction
        return act;
    }
    return 0;
}

//----------------
void FingerCount::reset()
{
    QAction * actMenu = fingerAction[ curIdMenu * 10];
    if (actMenu)
    {
        //QMenu *menu = actMenu->menu();
        //menu->close();
        //m_menuBar->activeAction();
    }

    curIdMenu = 0;
    curIdItem = 0;
    selectCurAction();
}

//----------------
QAction* FingerCount::selectCurAction(bool continuous) {
    qDebug()<<"select menu: "<<curIdMenu<<" action: "<<curIdItem;
    QAction * actMenu = fingerAction[ curIdMenu * 10];
    if (!actMenu) {
        m_menuBar->setActiveAction(0);
        return 0;
    }
    m_menuBar->setActiveAction(actMenu);
    QMenu *menu = actMenu->menu();
    QAction *act = fingerAction[ curIdMenu * 10 + curIdItem + 100 * curIdSec];
    QAction *actCont = fingerContinuousAction[ curIdMenu * 10 + curIdItem + 100 * curIdSec];
    if (!(act))
        act = fingerAction[ curIdMenu * 10 + curIdItem ];
    menu->setActiveAction(act);
    if (act)
    {
        if (actCont && continuous)
        {
            emit continuousCommandSelected(act->text());
        }
        else
            emit commandSelected(act->text());
    } else
    {
        emit commandSelected("");
    }
    return act;
}

//----------------
QAction* FingerCount::activateCurAction() {
    qDebug()<<"activate menu: "<<curIdMenu<<" action: "<<curIdItem;
    if (curIdMenu == 0)
        return 0;
    //selectCurAction();
    QAction *act = fingerAction[ curIdMenu * 10 + curIdItem + 100 * curIdSec];
    QAction *actCont = fingerContinuousAction[ curIdMenu * 10 + curIdItem + 100 * curIdSec];

    if (act)
    {
        act->trigger();
        if (actCont)
            emit continuousCommandActivated(act->text());
        else
            emit commandActivated(act->text());
        curIdItem = 0;
        //this->selectCurAction();
    }
    return act;
}


//----------------
QMenu* FingerCount::insertMenu(QAction* before , const QString & name, int fc)
{
    QMenu *menu = new QMenu(name);
    return insertMenu(before,menu, fc);
}
//-----------------
QString shortcutSymbol(int id, bool fingerCount)
{
    QString res;
    if (fingerCount)
    {
        res.setNum(id);
    }
    else
    {
        if (id==1) res= QChar(8593);
        if (id==2) res= QChar(8599);
        if (id==3) res= QChar(8594);
        if (id==4) res= QChar(8600);
        if (id==5) res= QChar(8595);
        if (id==6) res= QChar(8601);
        if (id==7) res= QChar(8592);
        if (id==8) res= QChar(8598);
    }
    return res;
}

//----------------
QMenu* FingerCount::insertMenu(QAction* before , QMenu* menu, int fc)
{
    if (!menu)
    {
        qDebug()<<"FingerCount::addMenu(QMenu*, int fc)";
        qDebug()<<"menu==0 -> exit(1)";
        exit(1);

    }

    if (fc>0)
    {
        QString shortcut;
        if (fc==1)shortcut = "a";
        if (fc==2)shortcut = "b";
        if (fc==3)shortcut = "c";
        if (fc==4)shortcut = "d";
        if (fc==5)shortcut = "e";

        QAction* act = menu->menuAction();
        act->setShortcut(QKeySequence(shortcut));
//        act->setText(menu->title() + "  " + QString::number(fc));
        act->setText(menu->title() + "  " + shortcutSymbol(fc, FINGER_COUNT) + " ");

        fingerAction[fc*10]= act;
    }
    m_menuBar->insertMenu(before,menu);
    return menu;
}
//-----------------
QMenu* FingerCount::addMenu(const QString& name, int fc)
{
    QMenu* menu = new QMenu(name);
    return insertMenu(0,menu,fc);
}

//-----------------
QMenu* FingerCount::addMenu(QMenu* menu, int fc)
{
    return insertMenu(0,menu,fc);
}

//-----------------
QAction* FingerCount::addAction( QAction * act, int fc, bool discrete, FCSecond secFav)
{
    if (fc <=0)
        return 0;

    QList<QWidget*> associated = act->associatedWidgets();
    QMenu *menu =0;
    for (int i = 0; i < associated.size(); i++)
    {
        QWidget *widget = associated.at(i);
        menu = dynamic_cast<QMenu*>(widget);
        if (menu)
        {
            i = 100; //break
        }
    }

    if (!menu)
    {
        qDebug()<<__PRETTY_FUNCTION__;
        qDebug()<<"no attached menu -> exit(1)";
        exit(1);
    }
    QString keySeq;
    if (secFav == UP) {
      fc+= 100;
      keySeq = QChar(8673);
    }
    else if (secFav == DOWN)
    {
      fc += 200;
      keySeq = QChar(8675);
    }
    else if (secFav == DIRECT) {
      keySeq = shortcutSymbol(fc, FINGER_COUNT);//+","+QChar(8195);
    }
    if (!discrete) {
      keySeq = keySeq + "," + QChar(10161);
    }
    act->setShortcut(QKeySequence(keySeq));
    QAction *actMenu = menu->menuAction();
    int key = fingerAction.key(actMenu, -1);
    if (key==-1)
    {
        qDebug()<<"menu has no finger count shortcut";
        exit(1);
    }
    fingerAction[key + fc] = act;
    if (!discrete)
        fingerContinuousAction[key +fc] = act;
    return act;
}


//-----------------
QAction* FingerCount::insertAction(QAction* before , QMenu* menu, const QString& name, int fc, bool discrete,FCSecond secFav)
{
    QAction* act= new QAction(name, 0);
    return insertAction(before,menu, act, fc, discrete,secFav);
}

//-----------------
QAction* FingerCount::insertAction(QAction* before , QMenu* menu, QAction * act, int fc, bool discrete,FCSecond secFav)
{
    if (!menu || !act)
    {
        qDebug()<< __PRETTY_FUNCTION__;
        qDebug()<<"menu==0 || act ==0 -> exit(1)";
        exit(1);

    }
    if (fc>0)
    {
        QString keySeq;
	if (secFav == UP) {
	  fc+= 100;
	  keySeq = QChar(8673);
	}
	else if (secFav == DOWN)
	{
	  fc += 200;
	  keySeq = QChar(8675);
	}
	else if (secFav == DIRECT) {
	  keySeq = shortcutSymbol(fc, FINGER_COUNT);//+","+QChar(8195);
	}
	if (!discrete) {
	  keySeq = keySeq + "," + QChar(10161);
	}
        act->setShortcut(QKeySequence(keySeq));
        QAction *actMenu = menu->menuAction();
        int key = fingerAction.key(actMenu, -1);
        if (key==-1)
        {
            qDebug()<<"menu has no finger count shortcut";
            exit(1);
        }
        fingerAction[key + fc] = act;
        if (!discrete)
            fingerContinuousAction[key +fc] = act;
    }

    menu->insertAction(before,act);
    return act;
}

QAction* FingerCount::addAction(QMenu* menu, const QString& name, int fc, bool discrete, FCSecond secFav)
{
    return insertAction(0,menu,name,fc,discrete,secFav);
}
QAction* FingerCount::addAction(QMenu* menu, QAction* act, int fc, bool discrete, FCSecond secFav)
{
    return insertAction(0,menu,act,fc,discrete,secFav);
}



#ifdef USECMAKE
#include "fingercount.moc"
#endif

