
# CMake module to search for QTUIOG library
#
# If it's found it sets QTUIO_FOUND to TRUE
# and following variables are set:
#    QTUIOG_INCLUDE_DIR
#    QTUIOG_LIBRARY


FIND_PATH(QTUIOG_INCLUDE_DIR qtuio.h 
  /usr/local/include/QTuioG 
  /usr/include/QTuioG 
  c:/msys/local/include/QTuioG
  #MSVC
  C:/dev/cpp/qtuiog
  )

FIND_LIBRARY(QTUIOG_LIBRARY NAMES QTuioG PATHS 
  /usr/local/lib 
  /usr/lib 
  c:/msys/local/lib
  #MSVC
  C:/dev/cpp/qtuio
  )

IF (QTUIOG_INCLUDE_DIR AND QTUIOG_LIBRARY)
   SET(QTUIOG_FOUND TRUE)
ENDIF (QTUIOG_INCLUDE_DIR AND QTUIOG_LIBRARY)


IF (QTUIOG_FOUND)

   IF (NOT QTUIOG_FIND_QUIETLY)
      MESSAGE(STATUS "Found QTUIOG: ${QTUIOG_LIBRARY}")
   ENDIF (NOT QTUIOG_FIND_QUIETLY)

ELSE (QTUIOG_FOUND)

   IF (QTUIOG_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find QTUIOG")
   ENDIF (QTUIOG_FIND_REQUIRED)

ENDIF (QTUIOG_FOUND)
